#!/bin/bash

if [ -z "$1" ]; then

 echo "Usage:"
 echo
 echo "pdaanalyse.sh /pfad/zur/aufnahme/2007-01-01.00.00.50.50.rec"
 echo

else

source /etc/pdaexport/pdaglobal.conf

INPUT="$1"
NAME=""

if [ -e "$INPUT"/pdaexport.marker"" ]; then
 source $INPUT"/pdaexport.marker"
else
 source /etc/pdaexport/pdaexport.conf
fi

NAMECOUNTER="2"
while [ "$NAMECOUNTER" -le "12" ]; do
 TNAME="$(echo $INPUT|cut -d "/" -f $NAMECOUNTER)"
 if [ -z "$TNAME" ]; then break
 elif [ -n "$(echo $VIDEODIR|grep "$TNAME")" ]; then TNAME=""
 elif [ -n "$(echo $TNAME|grep "20"|grep ".rec")" ]; then DATE="$(echo $TNAME|cut -b1-10)"
 elif [ "$(echo $TNAME|cut -b1)" == "_" -o "$(echo $TNAME|cut -b1-2)" == "%_" ]; then 
  SERIE="1"
  TNAME=""
 elif [ -z "$NAME" ]; then NAME=$TNAME
  else NAME=$NAME"_-_"$TNAME
 fi
 NAMECOUNTER=$[$NAMECOUNTER+1]
done

NAME="$(echo $NAME|tr -d "%")"
NAME="$(echo $NAME|tr -d "'")"
NAME="$(echo $NAME|sed -e 's/[@;(;);!;:;&;"]/#/g')"

if [ -n "$SERIE" ]; then 
 if [ -n "$DATE" ]; then
  NAME=$NAME"_-_"$DATE
 else
  NAME=$NAME"_-_NO_DATE_"$TIME
 fi
fi

echo "Exportname : $NAME"."$EXT"

OSIZE="$(du -L -h -c $INPUT|tail -n1|awk {'print $1'})"
echo "Originalgre : $OSIZE"

INDEXSIZE="$(ls -l $INPUT|grep "index.vdr"|awk {'print $5'})"
LENGTH="$[$INDEXSIZE/8/25]"
echo "Spielzeit (ca.) : "$[$LENGTH/60]"Min."

if [ -z "$SIZE" ]; then
 ASIZE="$[$ABITRATE*$LENGTH/8]"
 VSIZE="$[$VBITRATE*$LENGTH/8]"
 SIZE="$[($VSIZE+$ASIZE)/1024]"
else
 TSIZE="$[$SIZE*1024]"
 INDEXSIZE="$(ls -l $INPUT|grep "index.vdr"|awk {'print $5'})"
 LENGTH="$[$INDEXSIZE/8/25]"
 ASIZE="$[$ABITRATE*$LENGTH/8]"
 TSIZE="$[$TSIZE-$ASIZE]"
 VBITRATE="$[$TSIZE*8/$LENGTH]"
fi

echo "Exportgre (ca.) : $SIZE"M""
echo "Video-Bitrate : "$VBITRATE"kb/s"

#Die Bildkoordinaten werden errechnet!
OSCALEG="$($MPLAYER $INPUT/001.vdr -v -frames 0 2>/dev/null|grep "VIDEO: "|awk {'print $3'})"
if [ -z "$OSCALEG" ]; then
 OSCALEG="720x576"
 echo "Original-Auflsung (geschtzt) : "$OSCALEG
else
 echo "Original-Auflsung : "$OSCALEG
fi
OSCALEX="$(echo "$OSCALEG"|cut -d"x" -f1)"
OSCALEY="$(echo "$OSCALEG"|cut -d"x" -f2)"

if [ -n "$CROP" ]; then
 CROPCOUNTER="30"
 CROP1="0"
 CROP2="0"
 while [ "$CROPCOUNTER" -le 600 ]; do
  CROPTMP="$($MPLAYER $INPUT/001.vdr -vo null -ao null -ss $CROPCOUNTER -vf cropdetect -frames 5 2>/dev/null|grep "vf crop"|tail -n1|cut -d"=" -f2|cut -d")" -f1)"
  if [ -n "$CROPTMP" ]; then
   CROPTMP1="$(echo "$CROPTMP"|cut -d":" -f1)"
   CROPTMP2="$(echo "$CROPTMP"|cut -d":" -f2)"
   CROPTMP3="$(echo "$CROPTMP"|cut -d":" -f3)"
   CROPTMP4="$(echo "$CROPTMP"|cut -d":" -f4)"
   if [ "$CROPTMP1" -gt "$CROP1" ]; then
    CROP1="$CROPTMP1"
    CROP3="$CROPTMP3"
   fi
   if [ "$CROPTMP2" -gt "$CROP2" ]; then
    CROP2="$CROPTMP2"
    CROP4="$CROPTMP4"
   fi
  fi
  CROPCOUNTER="$[$CROPCOUNTER+30]"
 done
 if [ "$CROP1" == "0" ]; then
  CROP1="$OSCALEX"
  CROP2="$OSCALEY"
  CROP3="0"
  CROP4="0"
  echo "Original-Bildformat (geschtzt) : "$CROP1"x"$CROP2
 else
  echo "Original-Bildformat : "$CROP1"x"$CROP2
 fi
 FFMCL="$CROP3"
 FFMCR="$[$OSCALEX-$CROP3-$CROP1]"
 FFMCT="$CROP4"
 FFMCB="$[$OSCALEY-$CROP4-$CROP2]"
 RRATIO="$(echo "scale=2;($CROP1/$CROP2)/($OSCALEX/$OSCALEY)"|bc -l)"
else
 RRATIO="1"
 FFMCL="0"
 FFMCR="0"
 FFMCT="0"
 FFMCB="0"
fi
echo "Original-Seitenverhltnis : "$RRATIO

#SCALE wird bearbeitet (ggf. auf Original-Auflsung gesetzt, gezoomt oder fr 16x9 angepasst)!
if [ -z "$SCALE" ]; then
 SCALE="$($MPLAYER $INPUT/001.vdr -v -frames 0 2>/dev/null|grep "VIDEO: "|awk {'print $3'})"
 if [ -z "$SCALE" ]; then SCALE="$SAVESCALE"
 fi
fi

if [ -n "$($MPLAYER $INPUT/001.vdr -v -frames 0 2>/dev/null|grep "(aspect 3)")" ]; then
 if [ "$ZOOM" != "0" ]; then
  SCALE="$(echo "$SCALE"|cut -d"x" -f1)"
 fi
 if [ -z "$ZOOM" ]; then
  if [ "$(echo "scale=2;$SCALE/16*9/$RRATIO/16"|bc -l|cut -d"." -f2)" -gt "49" ]; then
   SCALE="$SCALE"x"$(echo "scale=0;($SCALE/16*9/$RRATIO/16+1)*16"|bc -l)"
  else
   SCALE="$SCALE"x"$(echo "scale=0;$SCALE/$RRATIO/16*9/16*16"|bc -l)"
  fi
  echo "Ziel-Auflsung (16x9) : "$SCALE
  if [ -n "$CROP" ]; then
   echo "Crop-Parameter : L-"$FFMCL" R-"$FFMCR" O-"$FFMCT" U-"$FFMCB
  fi
 elif [ "$ZOOM" == "0" ]; then
  echo "Ziel-Auflsung (Fix) : "$SCALE
  elif [ "$ZOOM" == "1" ]; then
  if [ "$(echo "scale=2;$SCALE/4*3/$RRATIO/16"|bc -l|cut -d"." -f2)" -gt "49" ]; then
   SCALE="$SCALE"x"$(echo "scale=0;($SCALE/4*3/$RRATIO/16+1)*16"|bc -l)"
  else
   SCALE="$SCALE"x"$(echo "scale=0;$SCALE/$RRATIO/4*3/16*16"|bc -l)"
  fi
  ZOOMPIXEL="$(echo "scale=0;($OSCALEX-($OSCALEX/16*12))/2"|bc -l)"
  echo "Ziel-Auflsung (16x9-Zoom) : "$SCALE
  echo "Crop-Parameter : L-"$[$ZOOMPIXEL+$FFMCL]" R-"$[$ZOOMPIXEL+$FFMCR]" O-"$FFMCT" U-"$FFMCB
 elif [ "$ZOOM" == "2" ]; then
  if [ "$FFMCT" -gt "16" -a "$FFMCB" -gt "16"  ]; then
   if [ "$(echo "scale=2;$SCALE/4*3/$RRATIO/16"|bc -l|cut -d"." -f2)" -gt "49" ]; then
    SCALE="$SCALE"x"$(echo "scale=0;($SCALE/4*3/$RRATIO/16+1)*16"|bc -l)"
   else
    SCALE="$SCALE"x"$(echo "scale=0;$SCALE/$RRATIO/4*3/16*16"|bc -l)"
   fi
   ZOOMPIXEL="$(echo "scale=0;($OSCALEX-($OSCALEX/16*12))/2"|bc -l)"
   echo "Ziel-Auflsung (16x9-CS-Zoom) : "$SCALE
   echo "Crop-Parameter : L-"$[$ZOOMPIXEL+$FFMCL]" R-"$[$ZOOMPIXEL+$FFMCR]" O-"$FFMCT" U-"$FFMCB
  else
   if [ "$(echo "scale=2;$SCALE/16*9/$RRATIO/16"|bc -l|cut -d"." -f2)" -gt "49" ]; then
    SCALE="$SCALE"x"$(echo "scale=0;($SCALE/16*9/$RRATIO/16+1)*16"|bc -l)"
   else
    SCALE="$SCALE"x"$(echo "scale=0;$SCALE/$RRATIO/16*9/16*16"|bc -l)"
   fi
   echo "Ziel-Auflsung (16x9) : "$SCALE
   echo "Crop-Parameter : L-"$FFMCL" R-"$FFMCR" O-"$FFMCT" U-"$FFMCB
  fi
 fi
else
 if [ -n "$CROP" ]; then
  SCALE="$(echo "$SCALE"|cut -d"x" -f1)"
  if [ "$(echo "scale=2;$SCALE/4*3/$RRATIO/16"|bc -l|cut -d"." -f2)" -gt "49" ]; then
   SCALE="$SCALE"x"$(echo "scale=0;($SCALE/4*3/$RRATIO/16+1)*16"|bc -l)"
  else
   SCALE="$SCALE"x"$(echo "scale=0;$SCALE/$RRATIO/4*3/16*16"|bc -l)"
  fi
  echo "Ziel-Auflsung (4x3) : "$SCALE
  echo "Crop-Parameter : L-"$FFMCL" R-"$FFMCR" O-"$FFMCT" U-"$FFMCB
 fi
fi

#pdalanginfo.sh $INPUT

echo -n "Benutze Tonspur : "

TMPASTREAM="$(pdalanginfo.sh $INPUT|grep "$ASTREAM"|head -n1|awk {' print $2 '})"
TMPLANG="$(pdalanginfo.sh $INPUT|grep "$ASTREAM"|head -n1|awk {' print $4 '})"

if [ -z "$TMPASTREAM" ]; then
 TMPASTREAM="$(pdalanginfo.sh $INPUT|grep "$SAVEASTREAM"|head -n1|awk {' print $2 '})"
fi

echo $TMPASTREAM" - "$TMPLANG

fi