#!/bin/bash

if [ -z "$1" ]; then

 echo "Usage:"
 echo
 echo "pdaexport.sh /pfad/zur/aufnahme/2007-01-01.00.00.50.50.rec"
 echo

else

#Globale Variablen
source /etc/pdaexport/pdaglobal.conf

#Einige lokale Variablen
INPUT="$1"
ID="$2"
NAME=""

#Bei Mehrfachexport wird die Konfiguration aus dem Marker gelesen,
#sonst aus der Std.-Conf
if [ -n "$ID" ]; then
 source $INPUT"/pdaexport.marker"
 echo "Benutztes Profil:">>$PDAEXPORTLOG
 cat $INPUT"/pdaexport.marker">>$PDAEXPORTLOG
else
 source /etc/pdaexport/pdaexport.conf
 echo "Benutztes Profil:">$PDAEXPORTLOG
 cat /etc/pdaexport/pdaexport.conf>>$PDAEXPORTLOG
fi

#Debug?
VDRSYNCDEBUG=""
if [ -n "$DEBUG" ]; then
 exec 1>>$PDAEXPORTLOG 2>&1
 VDRSYNCDEBUG="-d"
 set -x
fi

#Wenn eine SD-Karte als Ziel angegeben ist, wird geprft ob sie zu mounten ist
#und ggf. als Export-Pfad benutzt
if [ -n "$SDEXPORTPATH" ]; then
 if [ -z "$(mount|grep "$SDEXPORTPATH")" ]; then
  mount $SDEXPORTPATH
  if [ -n "$(mount|grep "$SDEXPORTPATH")" ]; then
   EXPORTPATH="$SDEXPORTPATH"
   echo "Export-Ziel-Pfad auf $SDEXPORTPATH gendert!">>$PDAEXPORTLOG
   SDUNMOUNT="1"
  fi
 else
  EXPORTPATH="$SDEXPORTPATH"
  echo "Export-Ziel-Pfad auf $SDEXPORTPATH gendert!">>$PDAEXPORTLOG
 fi
fi

#Hier wird der Name aus dem Pfad extrahiert (Anzahl der Ebenen 13)!
NAMECOUNTER="2"
while [ "$NAMECOUNTER" -le "12" ]; do
 TNAME="$(echo $INPUT|cut -d "/" -f $NAMECOUNTER)"
 if [ -z "$TNAME" ]; then break
 elif [ -n "$(echo $VIDEODIR|grep "$TNAME")" ]; then TNAME=""
 elif [ -n "$(echo $TNAME|grep "20"|grep ".rec")" ]; then DATE="$(echo $TNAME|cut -b1-10)"
 elif [ "$(echo $TNAME|cut -b1)" == "_" -o "$(echo $TNAME|cut -b1-2)" == "%_" ]; then 
  SERIE="1"
  TNAME=""
 elif [ -z "$NAME" ]; then NAME=$TNAME
  else NAME=$NAME"_-_"$TNAME
 fi
 NAMECOUNTER=$[$NAMECOUNTER+1]
done
#Entferne "Sonderzeichen" aus dem Namen
NAME="$(echo $NAME|tr -d "%")"
NAME="$(echo $NAME|tr -d "'")"
NAME="$(echo $NAME|sed -e 's/[@;(;);!;:;&;"]/#/g')"

#Ist die Var. SERIE gesetzt, wird hier noch das Datum angehngt.
#Ebenfalls wenn "_" oder "%_" im Pfad gefunden wurden!
if [ -n "$SERIE" ]; then 
 if [ -n "$DATE" ]; then
  NAME=$NAME"_-_"$DATE
 else
  NAME=$NAME"_-_NO_DATE_"$TIME
 fi
fi

echo "Exportname: $NAME.$EXT">>$PDAEXPORTLOG

#Wenn die Var. SIZE gesetzt ist, wird hier die BITRATE neu berechnet!
if [ -n "$SIZE" ]; then
 SIZE="$[$SIZE*1024]"
 INDEXSIZE="$(ls -l $INPUT|grep "index.vdr"|awk {'print $5'})"
 LENGTH="$[$INDEXSIZE/8/25]"
 ASIZE="$[$ABITRATE*$LENGTH/8]"
 SIZE="$[$SIZE-$ASIZE]"
 VBITRATE="$[$SIZE*8/$LENGTH*1000]"
 echo "Bitarte fr Size neu berechnet! Neue Bitrate: $[$VBITRATE/1000]">>$PDAEXPORTLOG
else
 VBITRATE="$[$VBITRATE*1000]"
fi

#Die Bildkoordinaten werden errechnet und die Schnittparameter festgelegt
OSCALEG="$($MPLAYER $INPUT/001.vdr -v -frames 0 2>/dev/null|grep "VIDEO: "|awk {'print $3'})"
if [ -z "$OSCALEG" ]; then
 OSCALEG="720x576"
 echo "Original-Auflsung (geschtzt) : "$OSCALEG>>$PDAEXPORTLOG
else
 echo "Original-Auflsung : "$OSCALEG>>$PDAEXPORTLOG
fi
OSCALEX="$(echo "$OSCALEG"|cut -d"x" -f1)"
OSCALEY="$(echo "$OSCALEG"|cut -d"x" -f2)"

if [ -n "$CROP" ]; then
 CROPCOUNTER="30"
 CROP1="0"
 CROP2="0"
 while [ "$CROPCOUNTER" -le 600 ]; do
  CROPTMP="$($MPLAYER $INPUT/001.vdr -vo null -ao null -ss $CROPCOUNTER -vf cropdetect -frames 5 2>/dev/null|grep "vf crop"|tail -n1|cut -d"=" -f2|cut -d")" -f1)"
  if [ -n "$CROPTMP" ]; then
   CROPTMP1="$(echo "$CROPTMP"|cut -d":" -f1)"
   CROPTMP2="$(echo "$CROPTMP"|cut -d":" -f2)"
   CROPTMP3="$(echo "$CROPTMP"|cut -d":" -f3)"
   CROPTMP4="$(echo "$CROPTMP"|cut -d":" -f4)"
   if [ "$CROPTMP1" -gt "$CROP1" ]; then
    CROP1="$CROPTMP1"
    CROP3="$CROPTMP3"
   fi
   if [ "$CROPTMP2" -gt "$CROP2" ]; then
    CROP2="$CROPTMP2"
    CROP4="$CROPTMP4"
   fi
  fi
  CROPCOUNTER="$[$CROPCOUNTER+30]"
 done
 if [ "$CROP1" == "0" ]; then
  CROP1="$OSCALEX"
  CROP2="$OSCALEY"
  CROP3="0"
  CROP4="0"
  echo "Original-Bildformat (geschtzt) : "$CROP1"x"$CROP2>>$PDAEXPORTLOG
 else
  echo "Original-Bildformat : "$CROP1"x"$CROP2>>$PDAEXPORTLOG
 fi
 FFMCL="$CROP3"
 FFMCR="$[$OSCALEX-$CROP3-$CROP1]"
 FFMCT="$CROP4"
 FFMCB="$[$OSCALEY-$CROP4-$CROP2]"
 RRATIO="$(echo "scale=2;($CROP1/$CROP2)/($OSCALEX/$OSCALEY)"|bc -l)"
else
 RRATIO="1"
 FFMCL="0"
 FFMCR="0"
 FFMCT="0"
 FFMCB="0"
fi
echo "Seitenverhltnis-Korrektur-Faktor: "$RRATIO>>$PDAEXPORTLOG


#SCALE wird bearbeitet (ggf. auf Original-Auflsung gesetzt, gezoomt oder fr 16x9 angepasst)!
if [ -z "$SCALE" ]; then
 SCALE="$($MPLAYER $INPUT/001.vdr -v -frames 0 2>/dev/null|grep "VIDEO: "|awk {'print $3'})"
 if [ -z "$SCALE" ]; then SCALE="$SAVESCALE"
 fi
fi

if [ -n "$($MPLAYER $INPUT/001.vdr -v -frames 0 2>/dev/null|grep "(aspect 3)")" ]; then
 if [ "$ZOOM" != "0" ]; then
  SCALE="$(echo "$SCALE"|cut -d"x" -f1)"
 fi
 if [ -z "$ZOOM" ]; then
  if [ "$(echo "scale=2;$SCALE/16*9/$RRATIO/16"|bc -l|cut -d"." -f2)" -gt "49" ]; then
   SCALE="$SCALE"x"$(echo "scale=0;($SCALE/16*9/$RRATIO/16+1)*16"|bc -l)"
  else
   SCALE="$SCALE"x"$(echo "scale=0;$SCALE/$RRATIO/16*9/16*16"|bc -l)"
  fi
  echo "Auflsung angepasst (16x9)! Neue Auflsung: "$SCALE >>$PDAEXPORTLOG
  if [ -n "$CROP" ]; then
   ZOOMOPT="-cropleft $FFMCL -cropright $FFMCR -croptop $FFMCT -cropbottom $FFMCB"
   echo "Option fr Crop generiert: $ZOOMOPT">>$PDAEXPORTLOG
  fi
 elif [ "$ZOOM" == "0" ]; then
  ZOOMOPT="-aspect 1.7777"
  echo "Auflsung (Fix): "$SCALE >>$PDAEXPORTLOG
  echo "Aspect gesetzt: "$ZOOMOPT >>$PDAEXPORTLOG
 elif [ "$ZOOM" -eq "1" ]; then
  if [ "$(echo "scale=2;$SCALE/4*3/$RRATIO/16"|bc -l|cut -d"." -f2)" -gt "49" ]; then
   SCALE="$SCALE"x"$(echo "scale=0;($SCALE/4*3/$RRATIO/16+1)*16"|bc -l)"
  else
   SCALE="$SCALE"x"$(echo "scale=0;$SCALE/$RRATIO/4*3/16*16"|bc -l)"
  fi
  ZOOMPIXEL="$(echo "scale=0;($OSCALEX-($OSCALEX/16*12))/2"|bc -l)"
  ZOOMOPT="-cropleft $[$ZOOMPIXEL+$FFMCL] -cropright $[$ZOOMPIXEL+$FFMCR] -croptop $FFMCT -cropbottom $FFMCB"
  echo "Auflsung angepasst(16x9-Zoom)! Neue Auflsung: "$SCALE >>$PDAEXPORTLOG
  echo "Option fr Crop generiert: $ZOOMOPT">>$PDAEXPORTLOG
 elif [ "$ZOOM" == "2" ]; then
  if [ "$FFMCT" -gt "16" -a "$FFMCB" -gt "16" ]; then
   if [ "$(echo "scale=2;$SCALE/4*3/$RRATIO/16"|bc -l|cut -d"." -f2)" -gt "49" ]; then
    SCALE="$SCALE"x"$(echo "scale=0;($SCALE/4*3/$RRATIO/16+1)*16"|bc -l)"
   else
    SCALE="$SCALE"x"$(echo "scale=0;$SCALE/$RRATIO/4*3/16*16"|bc -l)"
   fi
   ZOOMPIXEL="$(echo "scale=0;($OSCALEX-($OSCALEX/16*12))/2"|bc -l)"
   ZOOMOPT="-cropleft $[$ZOOMPIXEL+$FFMCL] -cropright $[$ZOOMPIXEL+$FFMCR] -croptop $FFMCT -cropbottom $FFMCB"
   echo "Auflsung angepasst(16x9-Cinescope-Zoom)! Neue Auflsung: "$SCALE >>$PDAEXPORTLOG
  else
   if [ "$(echo "scale=2;$SCALE/16*9/$RRATIO/16"|bc -l|cut -d"." -f2)" -gt "49" ]; then
    SCALE="$SCALE"x"$(echo "scale=0;($SCALE/16*9/$RRATIO/16+1)*16"|bc -l)"
   else
    SCALE="$SCALE"x"$(echo "scale=0;$SCALE/$RRATIO/16*9/16*16"|bc -l)"
   fi
   ZOOMOPT="-cropleft $FFMCL -cropright $FFMCR -croptop $FFMCT -cropbottom $FFMCB"
   echo "Auflsung angepasst(16x9)! Neue Auflsung: "$SCALE >>$PDAEXPORTLOG
  fi
  echo "Option fr Crop generiert: $ZOOMOPT">>$PDAEXPORTLOG
 fi
else
 if [ -n "$CROP" ]; then
  SCALE="$(echo "$SCALE"|cut -d"x" -f1)"
  if [ "$(echo "scale=2;$SCALE/4*3/$RRATIO/16"|bc -l|cut -d"." -f2)" -gt "49" ]; then
   SCALE="$SCALE"x"$(echo "scale=0;($SCALE/4*3/$RRATIO/16+1)*16"|bc -l)"
  else
   SCALE="$SCALE"x"$(echo "scale=0;$SCALE/$RRATIO/4*3/16*16"|bc -l)"
  fi
  echo "Auflsung angepasst (4x3)! Neue Auflsung: "$SCALE >>$PDAEXPORTLOG
  ZOOMOPT="-cropleft $FFMCL -cropright $FFMCR -croptop $FFMCT -cropbottom $FFMCB"
  echo "Option fr Crop generiert: $ZOOMOPT">>$PDAEXPORTLOG
 fi
fi

#Es wird berprft, ob ASTREAM eine Zahl ist oder ein Sprachkrzel
if [ -z "$(echo "$ASTREAM"|grep [0-9])" ]; then 
 if [ -z "$ASTREAM" ]; then ASTREAM="$SAVEASTREAM"
 fi
 ASTREAM="$(echo "$ASTREAM"|tr [A-Z] [a-z])"
 ASTREAM="$(pdalanginfo.sh $INPUT|grep "$ASTREAM"|head -n1|awk {' print $2 '})"
 if [ -z "$ASTREAM" ]; then
  ASTREAM="$SAVEASTREAM"
  echo -n "Tonspur nicht erkannt!">>$PDAEXPORTLOG
 else
  echo -n "Tonspur gefunden!">>$PDAEXPORTLOG
 fi 
 if [ -z "$SAVEMODE" ]; then
  $FFMPEG -i $INPUT/001.vdr -t 1 2>/tmp/ffmpegoutput.txt
  if [ -n "$(cat /tmp/ffmpegoutput.txt|grep "ac3"|grep "0.$ASTREAM")" ]; then
   ASTREAM="$[$ASTREAM+1]"
  fi
  rm /tmp/ffmpegoutput.txt
 fi
fi

echo "Tonspur $ASTREAM wird benutzt!">>$PDAEXPORTLOG

#Existiert bereits eine Datei mit dem Namen?
if [ -e "$EXPORTPATH/$NAME.$EXT" ]; then
 ENAME=$NAME"_-_"$TIME
 echo "Datei bereits vorhanden! Exportname gendert auf: "$ENAME>>$PDAEXPORTLOG
else
 ENAME=$NAME
fi

#Ab hier wird konvertiert....

cd $INPUT

$SVDRPSEND mesg "Beginne Export "$ID" ("$NAME"."$EXT")...."

if [ -z "$SAVEMODE" ]; then 
 
 echo -n "Beginne Export...">>$PDAEXPORTLOG
 date >>$PDAEXPORTLOG

 echo "FFMPEG wird gestartet: nice -n $NICE $FFMPEG -f mpeg -i /tmp/pdafifo-$TIME -map 0.0:0.0 -map 0.$ASTREAM:0.1 $ZOOMOPT -y $SPECIALOPT -vcodec $VCODEC -s $SCALE -b $VBITRATE -acodec $ACODEC -ar $ASRATE -ab $ABITRATE $EXPORTPATH/$ENAME.$EXT">>$PDAEXPORTLOG
  
 mkfifo /tmp/pdafifo-$TIME
 cat 0*.vdr >>/tmp/pdafifo-$TIME &
 nice -n $NICE $FFMPEG -f mpeg -i /tmp/pdafifo-$TIME $ZOOMOPT -y $SPECIALOPT -map 0.0:0.0 -map 0.$ASTREAM:0.1 -vcodec $VCODEC -s $SCALE -b $VBITRATE -acodec $ACODEC -ar $ASRATE -ab $ABITRATE $EXPORTPATH/$ENAME.$EXT </dev/null 2>>$PDAEXPORTLOG

 rm /tmp/pdafifo-$TIME
 
else

 echo -n "Beginne Resync... ">>$PDAEXPORTLOG
 date >>$PDAEXPORTLOG

 nice -n $NICE $VDRSYNC $INPUT -m $VDRSYNCDEBUG -ignore bd -basename $NAME -o $SAVEMODE >>$PDAEXPORTLOG
 
 echo -n "Resync beendet! ">>$PDAEXPORTLOG
 date >>$PDAEXPORTLOG

 echo -n "Beginne Export... ">>$PDAEXPORTLOG
 date >>$PDAEXPORTLOG

 if [ -e "$SAVEMODE/$NAME.mpg" ]; then
  SYNCNAME=$NAME".mpg"
  echo "Resync-Datei gefunden: "$SYNCNAME>>$PDAEXPORTLOG
 elif [ -e "$SAVEMODE/$NAME"1".mpg" ]; then
  SYNCNAME=$NAME"1.mpg"
  echo "Resync-Datei gefunden: "$SYNCNAME>>$PDAEXPORTLOG
 else
  echo "Resync-Datei nicht gefunden!">>$PDAEXPORTLOG
  echo "Export wird beendet!">>$PDAEXPORTLOG
  exit
 fi

 echo "FFMPEG wird gestartet: nice -n $NICE $FFMPEG -f mpeg -i $SAVEMODE/$SYNCNAME $ZOOMOPT -y $SPECIALOPT -map 0.0:0.0 -map 0.$ASTREAM:0.1 -vcodec $VCODEC -s $SCALE -b $VBITRATE -acodec $ACODEC -ar $ASRATE -ab $ABITRATE  $EXPORTPATH/$ENAME.$EXT">>$PDAEXPORTLOG

 nice -n $NICE $FFMPEG -f mpeg -i $SAVEMODE/$SYNCNAME $ZOOMOPT -y $SPECIALOPT -map 0.0:0.0 -map 0.$ASTREAM:0.1 -vcodec $VCODEC -s $SCALE -b $VBITRATE -acodec "$ACODEC" -ar $ASRATE -ab $ABITRATE $EXPORTPATH/$ENAME.$EXT </dev/null  2>>$PDAEXPORTLOG
 rm $SAVEMODE/$SYNCNAME

fi

 $SVDRPSEND mesg "Export $ID beendet ("$NAME"."$EXT")!"

 echo -n "Export beendet! ">>$PDAEXPORTLOG
 date >>$PDAEXPORTLOG
 
 if [ -n "$SAVELOG" ]; then
  mv $PDAEXPORTLOG $EXPORTPATH/$ENAME.log
 fi
 
 if [ "$SDUNMOUNT" == "1" ]; then
  unmount "$SDEXPORTPATH"
 fi
 
fi